/*
Copyright (C) 2013 Bengt Martensson.

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or (at
your option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program. If not, see http://www.gnu.org/licenses/.
*/

package org.harctoolbox.irscrutinizer.importer;

import java.awt.Component;
import java.io.File;
import java.io.IOException;
import java.text.ParseException;

/**
 * This class models reading from a file, but not a stream (Reader), or from a data base.
 */
public interface IFileImporter {

    public void load(File file) throws IOException, ParseException;

    public boolean loadFileSelector(Component component, String title, String defaultDir) throws IOException, ParseException;

    public boolean canImportDirectories();

    public String[][] getFileExtensions();
}
